#include "applicationscl.h"

volatile uint32_t timerbutton1, timerbutton2, timeranim1, timeranim2, timeranim3, timeranim4, timeranim5, timerdelay, timerwdttps, timeranim6, timeranim7,
				  timercolor;

//Funkcja opozniajaca
void delayapp(uint16_t time)
{
	timerdelay=time*10;
	while(timerdelay);
}

//Funkcja resetujaca licznik watchdog w TPS929120 w przypadku gdy jest zalaczony
void resetwatchdogtps(void)
{
	uint8_t temp;

	static uint8_t counter=0;
	if(!timerwdttps)
	{
		timerwdttps=700;
		temp=Read_data_TPS(counter, 0x70); //odczytanie rejestru statusowego
		if(temp & 0x20) //jezeli uklad znajduje sie w trybie fail state to powrot do normalnego trybu
		{
			TPS_Return_FS(counter);
		}
		counter++;
		if(counter>5) counter=0;
	}
}

//Funkcja odpowiedzialna za detekcje nacisniecia przycisku zmieniajacego stan zapal/wylacz oraz okreslajacego kierunek zapalenia/wylaczenia
void detectbutton(uint8_t *state, uint8_t *direction)
{
	static uint16_t elmdrg1=0, elmdrg2=0;
	static uint8_t  firsttime=1, tempbutton1=0, tempbutton2=0, statebutton1=0, statebutton2=0;

	//pierwsze odczytanie przyciskow po zalaczeniu zasilania
	if(firsttime)
	{
		firsttime=0;
		tempbutton1=wPB1;
		tempbutton2=wPB2;
	}

	//obsluga pierwszego przycisku
	if((wPB1!=tempbutton1) && !timerbutton1 && !statebutton1)
	{
		elmdrg1++;
		if(elmdrg1>300)
		{
			elmdrg1=0;
			if(*state) *state=0; else *state=1; //zmiana stanu wyjcia
			*direction=1;                       //okreslenie kierunku
			timerbutton1=intervaltimebutton;
			statebutton1=1;
		}
	}
	else
	{
		elmdrg1=0;
	}

	if(statebutton1 && !timerbutton1)
	{
		statebutton1=0;
		tempbutton1=wPB1;
	}

	//obsluga drugiego przycisku
	if((wPB2!=tempbutton2) && !timerbutton2 && !statebutton2)
	{
		elmdrg2++;
		if(elmdrg2>300)
		{
			elmdrg2=0;
			if(*state) *state=0; else *state=1; //zmiana stanu wyjcia
			*direction=2;                       //okreslenie kierunku
			timerbutton2=intervaltimebutton;
			statebutton2=1;
		}
	}
	else
	{
		elmdrg2=0;
	}

	if(statebutton2 && !timerbutton2)
	{
		statebutton2=0;
		tempbutton2=wPB2;
	}

}

//Funkcja obslugujaca mocowe diody LED odpowiedzialne za zalaczanie oraz wylaczanie
void powerled(uint8_t powerk, uint8_t direction, uint8_t state, uint8_t animation)
{
	static uint8_t helptemp1=0, mul1=1, mul2=1, mul3=1;
	static uint16_t val1=0, val2=0, val3=0;
	static uint16_t power=0, powertemp=0xffff;

	power=powerk*10;


	if(power)
	{
	//wybranie animacji
	switch(animation)
	{
	case 0: //zwykle zalacz/wylacz diod power led
		{
			if(powertemp!=power) //jezeli wartosc mocy ulegla zmianie to pozwol na wejscie do zmiany wartosci
				{
					powertemp=power;
					if(state) helptemp1=0; else helptemp1=1;
				}

		if(state && !helptemp1)
		{
			helptemp1=1;
			val1=power;
			val2=power;
			val3=power;
		}
		else if(!state && helptemp1)
		{
			helptemp1=0;
			val1=0;
			val2=0;
			val3=0;
		}
		break;
		}
	    case 1:  //stopniowe rozswietlanie lub gaszenie bez kierunku
		{
			if(!timeranim1)
			{
				timeranim1=50;

				mul1=val1/100;
				mul2=val2/100;
				mul3=val3/100;

				if(!mul1) mul1=1;
				if(!mul2) mul2=1;
				if(!mul3) mul3=1;

			if(state)  //zalaczenie diod led
			{
				if(val1<=power-(mul1*incrementpwr)) val1+=(mul1*incrementpwr);
				if(val2<=power-(mul2*incrementpwr)) val2+=(mul2*incrementpwr);
				if(val3<=power-(mul3*incrementpwr)) val3+=(mul3*incrementpwr);

				if(val1>power) val1-=1;
				if(val2>power) val2-=1;
				if(val3>power) val3-=1;
			}
			else  //wylaczenie diod led
			{
				if(val1>=(mul1*incrementpwr)) val1-=(mul1*incrementpwr);
				if(val2>=(mul2*incrementpwr)) val2-=(mul2*incrementpwr);
				if(val3>=(mul3*incrementpwr)) val3-=(mul3*incrementpwr);
			}
			}
		break;
		}
	    case 2: //stopniow rozsiwetlanie lub gaszeine bez kierunku versja 2
		{
				if(!timeranim2)
						{
						mul1=val1/100;
						mul2=val2/100;
						mul3=val3/100;

						if(!mul1) mul1=1;
						if(!mul2) mul2=1;
						if(!mul3) mul3=1;
						timeranim2=50;

					if(state) //stan zalaczony, stan wylaczony
					{
							if(val2>(power/6))
							{
								if(val1<=(power-(incrementpwr*mul1))) val1+=(incrementpwr*mul1);
								if(val3<=(power-(incrementpwr*mul3))) val3+=(incrementpwr*mul3);
							}
							if(val2<=(power-(incrementpwr*mul2))) val2+=(incrementpwr*mul2);

							if(val1>power) val1-=1;
							if(val2>power) val2-=1;
							if(val3>power) val3-=1;

					}
					else if(!state) //wylaczenie diod led
					{
							if(val2<(power-(power/2)))
							{
								   if(val1>=((incrementpwr*mul1))) val1-=(incrementpwr*mul1);
								   if(val3>=((incrementpwr*mul3))) val3-=(incrementpwr*mul3);
							}
							if(val2>=((incrementpwr*mul2))) val2-=(incrementpwr*mul2);

					}
						}

		break;
		}
	    case 3: //stopniowe rozswietlanie lub gaszenie z uzaleznieniem od kierunku
	    {
	    	if(!timeranim3)
	    	{
	    			mul1=val1/100;
	    			mul2=val2/100;
	    			mul3=val3/100;

	    			if(!mul1) mul1=1;
	    			if(!mul2) mul2=1;
	    			if(!mul3) mul3=1;
	    			timeranim3=50;

	    			if(state) //stan zalaczony przycisku
	    			{
	    				if(direction==1) //kierunek od przycisku pierwszego
	    				{
	    					if(val1<=power-(mul1*incrementpwr)) val1+=(mul1*incrementpwr);
	    					if(val1>power/10)
	    					{
	    					if(val2<=power-(mul2*incrementpwr)) val2+=(mul2*incrementpwr);
	    					}
	    					if(val2>power/10)
	    					{
	    					if(val3<=power-(mul3*incrementpwr)) val3+=(mul3*incrementpwr);
	    					}

	    					if(val1>power) val1--;
	    					if(val2>power) val2--;
	    					if(val3>power) val3--;
	    				}
	    				if(direction==2) //kierunek od przycisku drugiego
	    				{
	    					if(val3<=power-(mul3*incrementpwr)) val3+=(mul3*incrementpwr);
	    				    if(val3>power/10)
	    					{
	    				    if(val2<=power-(mul2*incrementpwr)) val2+=(mul2*incrementpwr);
	    					}
	    					if(val2>power/10)
	    					{
	    					if(val1<=power-(mul1*incrementpwr)) val1+=(mul1*incrementpwr);
	    				    }

	    					if(val1>power) val1--;
	    					if(val2>power) val2--;
	    					if(val3>power) val3--;
	    				}
	    			}
	    			else if(!state) //przycisk wylaczony
	    			{
	    				if(direction==1) //kierunek od przycisku pierwszego
	    			    {
	    					if(val3>=((incrementpwr*mul3))) val3-=(incrementpwr*mul3);
	    					if(val3<(power-(power/2)))
	    					{
	    					if(val2>=((incrementpwr*mul2))) val2-=(incrementpwr*mul2);
	    					}
	    					if(val2<(power-(power/2)))
	    					{
	    					if(val1>=((incrementpwr*mul1))) val1-=(incrementpwr*mul1);
	    					}

	    			    }
	    			    if(direction==2) //kierunek od przycisku drugiego
	    			    {
	    			    	if(val1>=((incrementpwr*mul1))) val1-=(incrementpwr*mul1);
	    			    	if(val1<(power-(power/2)))
	    			    	{
	    			        if(val2>=((incrementpwr*mul2))) val2-=(incrementpwr*mul2);
	    			    	}
	    			    	if(val2<(power-(power/2)))
	    			        {
	    			        if(val3>=((incrementpwr*mul3))) val3-=(incrementpwr*mul3);
	    			    	}
	    			    }
	    			}
	    	}
	    break;
	    }
	    case 4:
	    {
	     	if(!timeranim4)
	    	    	{
	    	    			mul1=val1/100;
	    	    			mul2=val2/100;
	    	    			mul3=val3/100;

	    	    			if(!mul1) mul1=1;
	    	    			if(!mul2) mul2=1;
	    	    			if(!mul3) mul3=1;
	    	    			timeranim4=50;

	    	    			if(state) //stan zalaczony przycisku
	    	    			{
	    	    				if(direction==2) //kierunek od przycisku pierwszego
	    	    				{
	    	    					if(val1<=power-(mul1*incrementpwr)) val1+=(mul1*incrementpwr);
	    	    					if(val1>power/10)
	    	    					{
	    	    					if(val2<=power-(mul2*incrementpwr)) val2+=(mul2*incrementpwr);
	    	    					}
	    	    					if(val2>power/10)
	    	    					{
	    	    					if(val3<=power-(mul3*incrementpwr)) val3+=(mul3*incrementpwr);
	    	    					}

	    	    					if(val1>power) val1--;
	    	    					if(val2>power) val2--;
	    	    					if(val3>power) val3--;
	    	    				}
	    	    				if(direction==1) //kierunek od przycisku drugiego
	    	    				{
	    	    					if(val3<=power-(mul3*incrementpwr)) val3+=(mul3*incrementpwr);
	    	    				    if(val3>power/10)
	    	    					{
	    	    				    if(val2<=power-(mul2*incrementpwr)) val2+=(mul2*incrementpwr);
	    	    					}
	    	    					if(val2>power/10)
	    	    					{
	    	    					if(val1<=power-(mul1*incrementpwr)) val1+=(mul1*incrementpwr);
	    	    				    }

	    	    					if(val1>power) val1--;
	    	    					if(val2>power) val2--;
	    	    					if(val3>power) val3--;
	    	    				}
	    	    			}
	    	    			else if(!state) //przycisk wylaczony
	    	    			{
	    	    				if(direction==2) //kierunek od przycisku pierwszego
	    	    			    {
	    	    					if(val3>=((incrementpwr*mul3))) val3-=(incrementpwr*mul3);
	    	    					if(val3<(power-(power/2)))
	    	    					{
	    	    					if(val2>=((incrementpwr*mul2))) val2-=(incrementpwr*mul2);
	    	    					}
	    	    					if(val2<(power-(power/2)))
	    	    					{
	    	    					if(val1>=((incrementpwr*mul1))) val1-=(incrementpwr*mul1);
	    	    					}

	    	    			    }
	    	    			    if(direction==1) //kierunek od przycisku drugiego
	    	    			    {
	    	    			    	if(val1>=((incrementpwr*mul1))) val1-=(incrementpwr*mul1);
	    	    			    	if(val1<(power-(power/2)))
	    	    			    	{
	    	    			        if(val2>=((incrementpwr*mul2))) val2-=(incrementpwr*mul2);
	    	    			    	}
	    	    			    	if(val2<(power-(power/2)))
	    	    			        {
	    	    			        if(val3>=((incrementpwr*mul3))) val3-=(incrementpwr*mul3);
	    	    			    	}
	    	    			    }
	    	    			}
	    	    	}
	    	    break;
	    }
	}
	}
	else
	{
		//jezeli moc jest zero to wpisanie wartosci zero
		val1=0;
		val2=0;
		val3=0;
	}
	//wpisanie wartosci do timerow
	pwrled1=val1;
	pwrled2=val2;
	pwrled3=val3;
}

//Funkcja obslugujaca animacje stopni
void stairsanimation( uint8_t direction, uint8_t state, uint8_t animation, uint8_t stairsamound, uint8_t tresh, uint8_t time)
{
	static uint8_t tempstate=0xff, flaga=0, flaga2=0, val1=0, flag3=0, mul1=0, tempstate2=0xff, tempstate3=0xff, flag5=0, flag4=0, tempdirect=0xff;
	int i;
	static int z=0;
	static uint8_t svalues[24]={0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	static uint8_t smul[24]={0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	static uint8_t status[24]={0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	uint8_t adr, output;



	//sprawdzenie czy nastapila zmiana zalaczenia lub wylaczenia jesli - tak to ustawienie flagi zezwalajacej na zalaczenie
	if(state!=tempstate)
	{
		tempstate=state;
		flaga=1;
		flaga2=1;
	}
	switch(animation)
	{
	case 0:  //zapalenie lub wygaszenie schodow bez plynnosic
	{
		if(flaga)
		{
			flaga=0;

			if(state) //zalaczenie wszystkich stopni
			{
				for(i=0; i<stairsamound; i++)
				{
					adr=i/4; //adres drivera
					output=i*3;
					output=output%12; //okreslenie pierwszego z trzech numerow wyjscia

					Write_data_TPS(adr,11- (output), powerdef);
					Write_data_TPS(adr,11- (output+1), powerdef);
					Write_data_TPS(adr,11- (output+2), powerdef);

					Control_Output_TPS(adr,11- (output), 1);
					Control_Output_TPS(adr,11- (output+1), 1);
					Control_Output_TPS(adr,11- (output+2), 1);
				}
			}
			else  //wylaczenie wszystkich stopni
			{
				for(i=0; i<stairsamound; i++)
				{
					adr=i/4; //adres drivera
					output=i*3;
					output=output%12; //okreslenie pierwszego z trzech numerow wyjscia

					Write_data_TPS(adr,11- (output), powerdef);
					Write_data_TPS(adr,11- (output+1), powerdef);
					Write_data_TPS(adr,11- (output+2), powerdef);

					Control_Output_TPS(adr,11- (output), 0);
					Control_Output_TPS(adr,11- (output+1), 0);
					Control_Output_TPS(adr,11- (output+2), 0);
				}
			}
		}
		break;
	}
	case 1: //zalaczanie schodka po schodku z okreslonym opoznieniem
	{
		if(flaga)
		{

		if(!timeranim5)
		{
			timeranim5=2000;

			if(state) //zalaczanie poszczegolnych schodow w zaleznosci od drivera
			{
				if(flaga2)
				{
					flaga2=0;

					if(tempdirect!=direction)
					{
					tempdirect=direction;

					if(direction==1) z=0;
					if(direction==2) z=stairsamound-1;
					}
				}


			adr=z/4; //adres drivera
			output=z*3;
			output=output%12; //okreslenie pierwszego z trzech numerow wyjscia

			status[z]=1;

			Write_data_TPS(adr,11- (output), powerdef);
			Write_data_TPS(adr,11- (output+1), powerdef);
		    Write_data_TPS(adr,11- (output+2), powerdef);

			Control_Output_TPS(adr,11- (output), 1);
			Control_Output_TPS(adr,11- (output+1), 1);
			Control_Output_TPS(adr,11- (output+2), 1);

			if(direction==1)
				{
				z++;
				if(z>(stairsamound-1))
					{
					flaga=0;
					z=stairsamound-1;
					}
				}
			if(direction==2)
				{
					z--;
					if(z<0)
						{
						flaga=0;
						z=0;
						}
				}
			}

			else //wylaczenie wszystkich driverow
						{
							if(flaga2)
							{
								flaga2=0;

								if(tempdirect!=direction)
								{
								tempdirect=direction;

								if(direction==2) z=0;
								if(direction==1) z=stairsamound-1;
								}

							}


						adr=z/4; //adres drivera
						output=z*3;
						output=output%12; //okreslenie pierwszego z trzech numerow wyjscia

						status[z]=0;

						Write_data_TPS(adr,11-output, 0);
						Write_data_TPS(adr,11-(output+1), 0);
					    Write_data_TPS(adr,11-(output+2), 0);

						Control_Output_TPS(adr,11-output, 0);
						Control_Output_TPS(adr,11-(output+1), 0);
						Control_Output_TPS(adr,11-(output+2), 0);

						if(direction==2)
							{
							z++;
							if(z>(stairsamound-1))
								{
								flaga=0;
								z=stairsamound-1;

								for(uint8_t t=0; t<stairsamound; t++)
								{
									if(status[t])
									{
										status[t]=0;

										adr=t/4; //adres drivera
										output=t*3;
										output=output%12; //okreslenie pierwszego z trzech numerow wyjscia

										Control_Output_TPS(adr,11-output, 0);
										Control_Output_TPS(adr,11-(output+1), 0);
										Control_Output_TPS(adr,11-(output+2), 0);
									}
								}
								}
							}
						if(direction==1)
							{
								z--;
								if(z<0)
									{
									flaga=0;
									z=0;

									for(uint8_t t=0; t<stairsamound; t++)
																	{
																		if(status[t])
																		{
																			status[t]=0;

																			adr=t/4; //adres drivera
																			output=t*3;
																			output=output%12; //okreslenie pierwszego z trzech numerow wyjscia

																			Control_Output_TPS(adr,11-output, 0);
																			Control_Output_TPS(adr,11-(output+1), 0);
																			Control_Output_TPS(adr,11-(output+2), 0);
																		}
																	}
									}
							}
						}
		}
		}
		break;
	}
	case 2:  //stopniowe zalaczanie pojedynczych schodow - negacja kierunkow
	{


		if(flaga)
		{
		if(!timeranim5)
		{
			timeranim5=2000;

			if(state) //zalaczanie poszczegolnych schodow w zaleznosci od drivera
			{
				if(flaga2)
				{
					flaga2=0;

					if(tempdirect!=direction)
					{
					tempdirect=direction;
					if(direction==2) z=0;
					if(direction==1) z=stairsamound-1;
					}
				}

			adr=z/4; //adres drivera
			output=z*3;
			output=output%12; //okreslenie pierwszego z trzech numerow wyjscia

			status[z]=1;

			Write_data_TPS(adr,11- (output), powerdef);
			Write_data_TPS(adr,11- (output+1), powerdef);
		    Write_data_TPS(adr,11- (output+2), powerdef);

			Control_Output_TPS(adr,11- (output), 1);
			Control_Output_TPS(adr,11- (output+1), 1);
			Control_Output_TPS(adr,11- (output+2), 1);

			if(direction==2)
				{
				z++;
				if(z>(stairsamound-1))
					{
					flaga=0;
					z=stairsamound-1;
					}
				}
			if(direction==1)
				{
					z--;
					if(z<0)
						{
						flaga=0;
						z=0;
						}
				}
			}

			else//wylaczenie wszystkich driverow
						{
							if(flaga2)
							{
								flaga2=0;

								if(tempdirect!=direction)
								{
								tempdirect=direction;
								if(direction==1) z=0;
								if(direction==2) z=stairsamound-1;
								}
							}

						adr=z/4; //adres drivera
						output=z*3;
						output=output%12; //okreslenie pierwszego z trzech numerow wyjscia

						status[z]=0;

						Write_data_TPS(adr,11-output, 0);
						Write_data_TPS(adr,11-(output+1), 0);
					    Write_data_TPS(adr,11-(output+2), 0);

						Control_Output_TPS(adr,11-output, 0);
						Control_Output_TPS(adr,11-(output+1), 0);
						Control_Output_TPS(adr,11-(output+2), 0);

						if(direction==1)
							{
							z++;
							if(z>(stairsamound-1))
								{
								flaga=0;
								z=stairsamound-1;

								for(uint8_t t=0; t<stairsamound; t++)
																{
																	if(status[t])
																	{
																		status[t]=0;

																		adr=t/4; //adres drivera
																		output=t*3;
																		output=output%12; //okreslenie pierwszego z trzech numerow wyjscia

																		Control_Output_TPS(adr,11-output, 0);
																		Control_Output_TPS(adr,11-(output+1), 0);
																		Control_Output_TPS(adr,11-(output+2), 0);
																	}
																}
								}
							}
						if(direction==2)
							{
								z--;
								if(z<0)
									{
									flaga=0;
									z=0;

									for(uint8_t t=0; t<stairsamound; t++)
																	{
																		if(status[t])
																		{
																			status[t]=0;

																			adr=t/4; //adres drivera
																			output=t*3;
																			output=output%12; //okreslenie pierwszego z trzech numerow wyjscia

																			Control_Output_TPS(adr,11-output, 0);
																			Control_Output_TPS(adr,11-(output+1), 0);
																			Control_Output_TPS(adr,11-(output+2), 0);
																		}
																	}
									}
							}
						}
		}
		}
		break;
	}
	case 3: //stopniowe rozjasnianie i gaszenie wszystkich schodow jednoczesnie
	{
		if(tempstate2!=state)
		{
			tempstate2=state;
			flag3=1;
		}

		if(flag3)
		{
			mul1=val1/10;
			if(!mul1) mul1=1;

		if(state) //zalaczenie wszystkich stopni
					{
						if(!timeranim6)
						{
						timeranim6=50;

						for(i=0; i<stairsamound; i++)
						{
							adr=i/4; //adres drivera
							output=i*3;
							output=output%12; //okreslenie pierwszego z trzech numerow wyjscia


							Write_data_TPS(adr,11- output, val1);
							Write_data_TPS(adr,11- (output+1), val1);
							Write_data_TPS(adr,11- (output+2), val1);

							if(!val1)
							{
							Control_Output_TPS(adr,11- output, 1);
							Control_Output_TPS(adr,11-(output+1), 1);
							Control_Output_TPS(adr,11-(output+2), 1);
						   }
							if(val1==63)
							{
								flag3=0;
							}
						}
						if(val1<=(63-(incrementpwr*mul1))) val1+=(incrementpwr*mul1); else if(val1<63) val1++;
						}
					}
					else  //wylaczenie wszystkich stopni
					{
					if(!timeranim6)
					{
						timeranim6=50;

						for(i=0; i<stairsamound; i++)
						{
							adr=i/4; //adres drivera
							output=i*3;
							output=output%12; //okreslenie pierwszego z trzech numerow wyjscia

							Write_data_TPS(adr,11-(output), val1);
							Write_data_TPS(adr,11-(output+1), val1);
							Write_data_TPS(adr,11-(output+2), val1);

							if(!val1)
							{
							Control_Output_TPS(adr,11-(output), 0);
							Control_Output_TPS(adr,11-(output+1), 0);
							Control_Output_TPS(adr,11-(output+2), 0);
							flag3=0;
							}
						}
						if(val1>=((incrementpwr*mul1))) val1-=(incrementpwr*mul1); else if(val1>0) val1--;
					}
					}
		}
		break;
	}
	case 4:
	{
		if(tresh>30)
		{
			tresh=30;
		}
		if(time>200)
		{
			time=200;
		}

		if(tempstate3!=state)
				{
					tempstate3=state;
					flag4=1;
					flag5=1;
				}
		if(flag4)
		{
			if(!timeranim7)
			{
				timeranim7=40+time;

				for(uint8_t k=0; k<stairsamound; k++)
				{
					smul[k]=svalues[k]/10;
					if(!smul[k]) smul[k]=1;
				}

				if(state)
				{
					if(flag5)
						{
							flag5=0;
							if(direction==1) z=0;
							if(direction==2) z=stairsamound-1;
					    }


						if(direction==1)
						{
						for(int p=0; p<=z; p++)
						{
							adr=p/4; //adres drivera
							output=p*3;
							output=output%12; //okreslenie pierwszego z trzech numerow wyjscia

							if(svalues[p]==0)
							{
								Control_Output_TPS(adr,11- (output), 1);
								Control_Output_TPS(adr,11- (output+1), 1);
								Control_Output_TPS(adr,11- (output+2), 1);
							}

						    if(svalues[p]<=(63-(incrementpwr*smul[p])))
							{
							svalues[p]+=(incrementpwr*smul[p]);
							Write_data_TPS(adr,11- (output), svalues[p]);
							Write_data_TPS(adr,11- (output+1), svalues[p]);
						    Write_data_TPS(adr,11- (output+2), svalues[p]);
							}
							else if(svalues[p]<63)
							{
							svalues[p]++;
							Write_data_TPS(adr,11- (output), svalues[p]);
							Write_data_TPS(adr,11- (output+1), svalues[p]);
						    Write_data_TPS(adr,11- (output+2), svalues[p]);
							}
						}
						}
						if(direction==2)
						{

							for(int p=(stairsamound-1); p>=z; p--)
							{
								adr=p/4; //adres drivera
								output=p*3;
								output=output%12; //okreslenie pierwszego z trzech numerow wyjscia

								if(svalues[p]==0)
								{
									Control_Output_TPS(adr,11- (output), 1);
									Control_Output_TPS(adr,11- (output+1), 1);
									Control_Output_TPS(adr,11- (output+2), 1);
								}

					    	if(svalues[p]<=(63-(incrementpwr*smul[p])))
						    {
						    svalues[p]+=(incrementpwr*smul[p]);
					        Write_data_TPS(adr,11- (output), svalues[p]);
							Write_data_TPS(adr,11- (output+1), svalues[p]);
					        Write_data_TPS(adr,11- (output+2), svalues[p]);
						    }
						    else if(svalues[p]<63)
							{
						    svalues[p]++;
							Write_data_TPS(adr,11- (output), svalues[p]);
							Write_data_TPS(adr,11- (output+1), svalues[p]);
						    Write_data_TPS(adr,11- (output+2), svalues[p]);
							}
						}
						}

						if(direction==1)
							{
							if((svalues[z]>(upthresh-30)))
							{
								if((z<stairsamound-1)) z++;
							}
							if((z==(stairsamound-1)) && (svalues[z]==63))	flag4=0;
							}
						if(direction==2)
							{
							if((svalues[z]>(upthresh-30)))
							{
								if((z>0)) z--;
							}
							if((!z) && (svalues[z]==63)) flag4=0;
							}
				}
				else
				{
										if(flag5)
											{
												flag5=0;
												if(direction==2) z=0;
												if(direction==1) z=stairsamound-1;
										    }

											if(direction==2)
											{
											for(int p=0; p<=z; p++)
											{
												adr=p/4; //adres drivera
												output=p*3;
												output=output%12; //okreslenie pierwszego z trzech numerow wyjscia

												//if(val1>=((incrementpwr*mul1))) val1-=(incrementpwr*mul1); else if(val1>0) val1--;
											    if(svalues[p]>=((incrementpwr*smul[p])))
												{
												svalues[p]-=(incrementpwr*smul[p]);
												Write_data_TPS(adr,11- (output), svalues[p]);
												Write_data_TPS(adr,11- (output+1), svalues[p]);
											    Write_data_TPS(adr,11- (output+2), svalues[p]);

											    if(svalues[p]==0) //jezeli wartosc jest 0 wtedy nalezy wylaczyc wyjscia
											   		  {
											   			Control_Output_TPS(adr,11- (output), 0);
											   			Control_Output_TPS(adr,11- (output+1), 0);
											   			Control_Output_TPS(adr,11- (output+2), 0);
											   		  }
												}
												else if(svalues[p]>0)
												{
												svalues[p]--;
												Write_data_TPS(adr,11- (output), svalues[p]);
												Write_data_TPS(adr,11- (output+1), svalues[p]);
											    Write_data_TPS(adr,11- (output+2), svalues[p]);

											    if(svalues[p]==0) //jezeli wartosc jest 0 wtedy nalezy wylaczyc wyjscia
											   		 {
											   		 	Control_Output_TPS(adr,11- (output), 0);
											   			Control_Output_TPS(adr,11- (output+1), 0);
											   			Control_Output_TPS(adr,11- (output+2), 0);
											   		 }
												}
											}
											}
											if(direction==1)
											{

												for(int p=(stairsamound-1); p>=z; p--)
												{
													adr=p/4; //adres drivera
													output=p*3;
													output=output%12; //okreslenie pierwszego z trzech numerow wyjscia

													  if(svalues[p]>=((incrementpwr*smul[p])))
																									{
																									svalues[p]-=(incrementpwr*smul[p]);
																									Write_data_TPS(adr,11- (output), svalues[p]);
																									Write_data_TPS(adr,11- (output+1), svalues[p]);
																								    Write_data_TPS(adr,11- (output+2), svalues[p]);

																								    if(svalues[p]==0) //jezeli wartosc jest 0 wtedy nalezy wylaczyc wyjscia
																								    {
																								    Control_Output_TPS(adr,11- (output), 0);
																								    Control_Output_TPS(adr,11- (output+1), 0);
																								    Control_Output_TPS(adr,11- (output+2), 0);
																								   	}
																									}
																									else if(svalues[p]>0)
																									{
																									svalues[p]--;
																									Write_data_TPS(adr,11- (output), svalues[p]);
																									Write_data_TPS(adr,11- (output+1), svalues[p]);
																								    Write_data_TPS(adr,11- (output+2), svalues[p]);

																								    if(svalues[p]==0) //jezeli wartosc jest 0 wtedy nalezy wylaczyc wyjscia
																								    {
																								   	Control_Output_TPS(adr,11- (output), 0);
																								   	Control_Output_TPS(adr,11- (output+1), 0);
																								   	Control_Output_TPS(adr,11- (output+2), 0);
																								   	}
																									}
										    	}
											}


											if(direction==2)
												{
												if((svalues[z]<(dwnthresh+tresh)))
												{
													if((z<stairsamound-1)) z++;
												}
												if((z==(stairsamound-1)) && (svalues[z]==0))
												{
													flag4=0;
															for(uint8_t f=0; f<stairsamound; f++)
															{
															if(svalues[f]!=0) flag4=1;
															}
												}
												}
											if(direction==1)
												{
												if((svalues[z]<(dwnthresh+tresh)))
												{
													if((z>0)) z--;
												}
												if((!z) && (svalues[z]==0))
												{
													flag4=0;
														for(uint8_t f=0; f<stairsamound; f++)
														{
															if(svalues[f]!=0) flag4=1;
														}
												}
												}
				}
			}
		}
		break;
	}
		case 5:
		{
			if(tresh>30)
			{
				tresh=30;
			}
			if(time>200)
			{
				time=200;
			}

			if(tempstate3!=state)
					{
						tempstate3=state;
						flag4=1;
						flag5=1;
					}
			if(flag4)
			{
				if(!timeranim7)
				{
					timeranim7=40+time;

					for(uint8_t k=0; k<stairsamound; k++)
					{
						smul[k]=svalues[k]/10;
						if(!smul[k]) smul[k]=1;
					}

					if(state)
					{
						if(flag5)
							{
								flag5=0;
								if(direction==2) z=0;
								if(direction==1) z=stairsamound-1;
						    }

							if(direction==2)
							{
							for(int p=0; p<=z; p++)
							{
								adr=p/4; //adres drivera
								output=p*3;
								output=output%12; //okreslenie pierwszego z trzech numerow wyjscia

								if(svalues[p]==0)
								{
									Control_Output_TPS(adr,11- (output), 1);
									Control_Output_TPS(adr,11- (output+1), 1);
									Control_Output_TPS(adr,11- (output+2), 1);
								}

							    if(svalues[p]<=(63-(incrementpwr*smul[p])))
								{
								svalues[p]+=(incrementpwr*smul[p]);
								Write_data_TPS(adr,11- (output), svalues[p]);
								Write_data_TPS(adr,11- (output+1), svalues[p]);
							    Write_data_TPS(adr,11- (output+2), svalues[p]);
								}
								else if(svalues[p]<63)
								{
								svalues[p]++;
								Write_data_TPS(adr,11- (output), svalues[p]);
								Write_data_TPS(adr,11- (output+1), svalues[p]);
							    Write_data_TPS(adr,11- (output+2), svalues[p]);
								}
							}
							}
							if(direction==1)
							{

								for(int p=(stairsamound-1); p>=z; p--)
								{
									adr=p/4; //adres drivera
									output=p*3;
									output=output%12; //okreslenie pierwszego z trzech numerow wyjscia

									if(svalues[p]==0)
									{
											Control_Output_TPS(adr,11- (output), 1);
											Control_Output_TPS(adr,11- (output+1), 1);
											Control_Output_TPS(adr,11- (output+2), 1);
									}

						    	if(svalues[p]<=(63-(incrementpwr*smul[p])))
							    {
							    svalues[p]+=(incrementpwr*smul[p]);
						        Write_data_TPS(adr,11- (output), svalues[p]);
								Write_data_TPS(adr,11- (output+1), svalues[p]);
						        Write_data_TPS(adr,11- (output+2), svalues[p]);
							    }
							    else if(svalues[p]<63)
								{
							    svalues[p]++;
								Write_data_TPS(adr,11- (output), svalues[p]);
								Write_data_TPS(adr,11- (output+1), svalues[p]);
							    Write_data_TPS(adr,11- (output+2), svalues[p]);
								}
							}
							}

							if(direction==2)
								{
								if((svalues[z]>(upthresh-tresh)))
								{
									if((z<stairsamound-1)) z++;
								}
								if((z==(stairsamound-1)) && (svalues[z]==63))	flag4=0;
								}
							if(direction==1)
								{
								if((svalues[z]>(upthresh-tresh)))
								{
									if((z>0)) z--;
								}
								if((!z) && (svalues[z]==63)) flag4=0;
								}
					}
					else
					{
											if(flag5)
												{
													flag5=0;
													if(direction==1) z=0;
													if(direction==2) z=stairsamound-1;
											    }

												if(direction==1)
												{
												for(int p=0; p<=z; p++)
												{
													adr=p/4; //adres drivera
													output=p*3;
													output=output%12; //okreslenie pierwszego z trzech numerow wyjscia

													//if(val1>=((incrementpwr*mul1))) val1-=(incrementpwr*mul1); else if(val1>0) val1--;
												    if(svalues[p]>=((incrementpwr*smul[p])))
													{
													svalues[p]-=(incrementpwr*smul[p]);
													Write_data_TPS(adr,11- (output), svalues[p]);
													Write_data_TPS(adr,11- (output+1), svalues[p]);
												    Write_data_TPS(adr,11- (output+2), svalues[p]);

												    if(svalues[p]==0) //jezeli wartosc jest 0 wtedy nalezy wylaczyc wyjscia
												   		  {
												   			Control_Output_TPS(adr,11- (output), 0);
												   			Control_Output_TPS(adr,11- (output+1), 0);
												   			Control_Output_TPS(adr,11- (output+2), 0);
												   		  }
													}
													else if(svalues[p]>0)
													{
													svalues[p]--;
													Write_data_TPS(adr,11- (output), svalues[p]);
													Write_data_TPS(adr,11- (output+1), svalues[p]);
												    Write_data_TPS(adr,11- (output+2), svalues[p]);

												    if(svalues[p]==0) //jezeli wartosc jest 0 wtedy nalezy wylaczyc wyjscia
												   		 {
												   		 	Control_Output_TPS(adr,11- (output), 0);
												   			Control_Output_TPS(adr,11- (output+1), 0);
												   			Control_Output_TPS(adr,11- (output+2), 0);
												   		 }
													}
												}
												}
												if(direction==2)
												{

													for(int p=(stairsamound-1); p>=z; p--)
													{
														adr=p/4; //adres drivera
														output=p*3;
														output=output%12; //okreslenie pierwszego z trzech numerow wyjscia

														  if(svalues[p]>=((incrementpwr*smul[p])))
																										{
																										svalues[p]-=(incrementpwr*smul[p]);
																										Write_data_TPS(adr,11- (output), svalues[p]);
																										Write_data_TPS(adr,11- (output+1), svalues[p]);
																									    Write_data_TPS(adr,11- (output+2), svalues[p]);

																									    if(svalues[p]==0) //jezeli wartosc jest 0 wtedy nalezy wylaczyc wyjscia
																									    {
																									    Control_Output_TPS(adr,11- (output), 0);
																									    Control_Output_TPS(adr,11- (output+1), 0);
																									    Control_Output_TPS(adr,11- (output+2), 0);
																									   	}
																										}
																										else if(svalues[p]>0)
																										{
																										svalues[p]--;
																										Write_data_TPS(adr,11- (output), svalues[p]);
																										Write_data_TPS(adr,11- (output+1), svalues[p]);
																									    Write_data_TPS(adr,11- (output+2), svalues[p]);

																									    if(svalues[p]==0) //jezeli wartosc jest 0 wtedy nalezy wylaczyc wyjscia
																									    {
																									   	Control_Output_TPS(adr,11- (output), 0);
																									   	Control_Output_TPS(adr,11- (output+1), 0);
																									   	Control_Output_TPS(adr,11- (output+2), 0);
																									   	}
																										}
											    	}
												}


												if(direction==1)
													{
													if((svalues[z]<(dwnthresh+tresh)))
													{
														if((z<stairsamound-1)) z++;
													}
													if((z==(stairsamound-1)) && (svalues[z]==0))
														{
														flag4=0;
														for(uint8_t f=0; f<stairsamound; f++)
														{
														if(svalues[f]!=0) flag4=1;
														}
														}
													}
												if(direction==2)
													{
													if((svalues[z]<(dwnthresh+tresh)))
													{
														if((z>0)) z--;
													}
													if((!z) && (svalues[z]==0))
														{
														flag4=0;
														for(uint8_t f=0; f<stairsamound; f++)
														{
														if(svalues[f]!=0) flag4=1;
														}
														}
													}
					}
				}
			}
			break;
		}

}
}

//Funkcja wpisujaca wartosci kolorow schodow
void changecolorstairs(uint8_t red, uint8_t green, uint8_t blue, uint8_t stairsamound)
{
	static uint8_t tempred=0xff, tempgreen=0xff, tempblue=0xff, flag1=1, tempstairsamound=24;
	uint8_t output, adr, tt;

	if(flag1)
	{
		tempred=red;
		tempgreen=green;
		tempblue=blue;
		tempstairsamound=stairsamound;
	}

	if(tempstairsamound!=stairsamound)
		{
		tempstairsamound=stairsamound;
		flag1=1;
		}

	if(!timercolor)
	{
		timercolor=300;

	if(tempred!=red)
	{
		if(tempred>red)
			{
			tt=tempred-red;
			if(tt>10) tempred-=10;
			else if(tt>5) tempred-=5;
			else tempred--;
			}
		else if(tempred<red)
			{
			tt=red-tempred;
			if(tt>10) tempred+=10;
			else if(tt>5) tempred+=5;
			else tempred++;
			}
		flag1=1;
	}
	if(tempgreen!=green)
	{
		if(tempgreen>green)
			{
			tt=tempgreen-green;
			if(tt>10) tempgreen-=10;
			else if(tt>5) tempgreen-=5;
			else tempgreen--;
			}
		else if(tempgreen<green)
			{
			tt=green-tempgreen;
			if(tt>10) tempgreen+=10;
			else if(tt>5) tempgreen+=5;
			else tempgreen++;
			}
		flag1=1;
	}
	if(tempblue!=blue)
	{
		if(tempblue>blue)
			{
			tt=tempblue-blue;
			if(tt>10) tempblue-=10;
			else if(tt>5) tempblue -=5;
			else tempblue--;
			}
		else if(tempblue<blue)
			{
			tt=blue-tempblue;
			if(tt>10) tempblue+=10;
			else if(tt>5) tempblue+=5;
			else tempblue++;
			}
		flag1=1;
	}

	if(flag1)
	{
		flag1=0;

		for(uint8_t y=0; y<stairsamound; y++)
		{
			adr=y/4; //adres drivera
			output=y*3;
			output=output%12; //okreslenie pierwszego z trzech numerow wyjscia

			Write_data_TPS(adr,0x20+(11- (output)), tempred);
			Write_data_TPS(adr,0x20+(11- (output+1)), tempgreen);
		    Write_data_TPS(adr,0x20+(11- (output+2)), tempblue);
		}
	}
	}
}

